/* Copyright
   (c) 2008 bitSplit(tm) Enterprises and its licensors.
   This notice supersedes all notices below.
   -----------------------------------------------------------------------------------------
*/
#ifndef	UUDefines_h
#define UUDefines_h
//------------------------------------------------------------------------------------------
// Christopher M. Knox
// 2008/03/18
//------------------------------------------------------------------------------------------

#include <Carbon/Carbon.h>
#include <stdio.h>

//------------------------------------------------------------------------------------------

#define kUU_1KB		(1L << 10)
#define kUU_1MB		(1L << 20)
#define kUU_1GB		(1L << 30)

#define MALLOC(_n)			(char *) malloc(1L, _n)
#define CALLOC(_n)			(char *) calloc(1L, _n)
#define FREE(_p)			free((char *) _p)

#define MEMCPY(_d,_s,_n)	memcpy(_d,_s,_n)
#define MEMSET(_d,_c,_n)	memset(_d,_c,_n)

//---

#ifndef MIN
#define MIN(_a,_b) (((_a) < (_b)) ? (_a) : (_b))
#endif

#ifndef MAX
#define MAX(_a,_b) (((_a) > (_b)) ? (_a) : (_b))
#endif

#ifndef RND
#define	RND(_f) ( ((_f) < 0.0) ? (long) ((_f) - 0.5) : (long) ((_f) + 0.5) )
#endif

#ifndef ABS
#define	ABS(_x) (((_x) < 0) ? -(_x) : (_x))
#endif

//---

#ifndef ulong
	typedef unsigned long   ulong;
#endif

#ifndef ushort
	typedef unsigned short  ushort;
#endif

#ifndef uchar
	typedef unsigned char   uchar;
#endif

#define	errcode long

#ifndef long8
	#define	long8 SInt64
#endif

#ifndef ulong8
	#define	ulong8 UInt64
#endif

typedef char string16K[16384];
typedef char string8K[8192];
typedef char string4K[4096];
typedef char string2K[2048];
typedef char string1K[1024];
typedef char string512[512];
typedef char string256[256];
typedef char string128[128];
typedef char string64[64];
typedef char string32[32];
typedef char string16[16];
typedef char string8[8];

//------------------------------------------------------------------------------------------
#endif