/* Copyright
   (c) 2008 bitSplit(tm) Enterprises and its licensors.
   This notice supersedes all notices below.
   -----------------------------------------------------------------------------------------
*/
#ifndef	UUTextParser_h
#define UUTextParser_h
//------------------------------------------------------------------------------------------
// Christopher M. Knox
// 2008/03/18
//------------------------------------------------------------------------------------------

#include "UUDefines.h"

class UUTextParser
{
	public:

		string64	fClassName;				
		short		fLocalDebugMessageOff;
		
		char		*fText;
		long8		fTextSize;
		long8		fAllocSize;
		long		fCurPos;

		string512   fTempStr;
		long		fFoundKey;
		long		fTempStartPos;
		bool		fAtLineStart;
	
	public:
					UUTextParser(void);
					~UUTextParser(void);

		errcode		mInit(short decon);
		errcode		mDispose(short decon);
		errcode		mError(errcode err);

		errcode		mDisposeText(void);
		errcode		mSetText(const char *filePath);
		errcode		mSetText(const char *text, long textSize);
		errcode		mWriteTextToFile(const char *inFilePath);
		errcode		mSetPos(long newPos);
		char		*mFindString(const char *str);
		errcode		mGetStringBetween(const char *str1, const char *str2, char *foundStr, long maxLen);
		errcode		mGetTextBetween(const char *str1, const char *str2, UUTextParser *foundTP);
		errcode		mReplaceString(const char *findStr,const char *replaceWith);
		errcode		mAddLF(void);
		errcode		mAddString(const char *text);
		errcode		mAddText(const char *text, long len);
		
		double		mGetNumber(const char *key,double defNum);
		char		*mGetString(const char *key,const char *defStr);
};

//------------------------------------------------------------------------------------------
#endif